[comment {--- !doctools ---}]
[comment { DSL :: kettle doc :: }]

[comment {- - -- --- ----- -------- ------------- ---------------------}]
[call [cmd {kettle doc-destination}] [arg path]]

The "doc" recipe generated by the [cmd {kettle doc}] command (see
below) saves the conversion results into the sub-directory specified
by option [option --with-doc-destination].

[para] This command declares that the results should be put into the
specified non-standard [arg path] instead of the default of
[file embedded].

To take effect it has to be run [emph before] [cmd {kettle doc}] is
run.

[emph Note] that the user is still able to override with by setting
[option --with-doc-destination] on the command line.

[list_begin options]
[include o_with_docdestination.inc]
[list_end]


[comment {- - -- --- ----- -------- ------------- ---------------------}]
[call [cmd {kettle doc}] [opt [arg docroot]]]

This command declares the presence of [package doctools]-based
documentation files under the directory [arg docroot], which is a path
relative to the source directory.

[para] If not specified [arg docroot] defaults to [file doc].

[para] While this command can be invoked multiple times, only the
first invokation will have an effect. Every invokation after that is
ignored.

The commands [cmd {kettle tcl}], [cmd {kettle critcl3}], and
[cmd {kettle gh-pages}] run this command implicitly, with the default
paths.

This means that if documentation is stored in a non-standard location
[cmd {kettle doc}] must be run explicitly before them, with the proper path.

[para] The package documentation directory is scanned to locate the
documentation files. They are recognized by containing any of the
marker strings

[list_begin itemized]
[item] "[const "[lb]manpage_begin"]"
[item] "[const "--- doctools ---"]"
[item] "[const "tcl\.tk//DSL doctools//EN//"]"
[list_end]

in their first 1024 characters. Possible documentation files are
rejected should they contain any of the anti-markers

[list_begin itemized]
[item] "[const "--- !doctools ---"]"
[item] "[const "!tcl\.tk//DSL doctools//EN//"]"
[list_end]

in their first 1024 characters. This last is necessary as doctools
include file feature allows the actual document content to start in an
include file which cannot operate without being includes from a master
file configuring it.

[para] When documentation files are found the command will define
recipes to convert the documentation into manpages and HTML files,
plus recipes install the conversion results. The conversion results
themselves are stored as specified by [cmd {kettle doc-destination}]
(see above) and associated options.

[list_begin definitions]
[def [const doc]]
[def [const install-doc-html]]
[def [const install-doc-manpages]]
[def [const uninstall-doc-html]]
[def [const uninstall-doc-manpages]]
[list_end]

[para] The command further extends the recipes

[list_begin definitions]
[def [const install-doc]]
[def [const install]]
[def [const uninstall-doc]]
[def [const uninstall]]
[list_end]

generating a recipe tree matching

[example {
  install
  -> install-doc
     -> install-doc-html
     -> install-doc-manpages

  uninstall
  -> uninstall-doc
     -> uninstall-doc-html
     -> uninstall-doc-manpages
}]

[para] The extended recipes may be created by this process. As other
declarations create similar trees these get merged together, enabling
a user to install parts of the sources at various levels of specifity,
from just a specific type of documentation up to all and sundry.

[para] HTML documentation is stored under the directory specified by
option [option --html-dir].

Manpages are stored under the directory specified by
option [option --man-dir].

The "doc" recipe uses the [syscmd dtplite] application to perform the
various conversions.

[list_begin options]
[include o_htmldir.inc]
[include o_mandir.inc]
[include o_with_dtplite.inc]
[list_end]

[para] To simplify usage the command heuristically detects
tklib/diagram based figures by means of internally calling the command
[cmd {kettle figures}] with default path arguments
([file [var doc-sources]/figures}].

[para] If the figures are placed in a non-standard location this
command has to be run before [cmd {kettle doc}], with the proper
paths.

[comment {- - -- --- ----- -------- ------------- ---------------------}]
